<?php
/*
 * $Horde: nic/lookup.php,v 1.1 2001/10/15 21:12:21 chuck Exp $
 *
 * Copyright 2000, 2001 Charles J. Hagenbuch, <chuck@horde.org>
 *
 * See the enclosed file LICENSE for license information (BSD). If you
 * did not receive this file, see http://www.horde.org/asl.php.
 */

require './lib/base.php';
require_once HORDE_BASE . '/lib/Text.php';

$title = _("Convert an IP to a Domain Name"); 
require $registry->getTemplatePath() . '/common-header.inc';
require './menu.php';

$results = '';

$ip = Horde::getFormData('ip'); 

if (ereg("([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)", $ip, $classes)) {
    $hostname = gethostbyaddr($ip);
    if (ereg("([0-9]+)\.([0-9]+)\.([0-9]+)\.([0-9]+)", $hostname, $classes)) {
        $results = '<p class="header">' . sprintf(_("%s has no reverse lookup"), $ip) . '</p>';
    } else {
        $results = "<p><b><a href=\"http://$hostname\" target=\"_blank\">$hostname</a></b></p>";
    }
} else {
    if ($results != '') {
        $results = "<p><b>Please check the IP number, $ip could have a typographical error.</b>";
    }
}

require $registry->getTemplatePath() . '/lookup/lookup.inc';
require $registry->getTemplatePath() . '/common-footer.inc';
$registry->shutdown();

?>
